<template>
  <div>
    <codemirror ref="myCm"
      :value="code" 
      :options="cmOptions"
      @ready="onCmReady"
      @focus="onCmFocus"
      @input="onCmCodeChange"
      @blur="onCmBlur"
    >
    </codemirror>
  </div>
</template>

<script>
import { codemirror } from 'vue-codemirror';
import 'codemirror/lib/codemirror.css';
import 'codemirror/theme/cobalt.css';
import 'codemirror/mode/javascript/javascript.js';
import 'codemirror/addon/scroll/simplescrollbars.js';
import 'codemirror/addon/scroll/simplescrollbars.css';
import gitDiff from 'git-diff';

export default {
  components: {
    codemirror
  },
  data () {
    return {
      path: '/a',
      code: '',
      cmOptions: {
        // codemirror options
        tabSize: 2,
        mode: 'text/javascript',
        theme: 'cobalt',
        lineNumbers: true,
        line: true,
        scrollbarStyle: 'overlay',
        // fullScreen: true,
        // more codemirror options, 更多 codemirror 的高级配置...
      }
    }
  },
  methods: {
    onCmReady(cm) {
      // console.log('the editor is readied!', cm)
    },
    onCmFocus(cm) {
      // console.log('the editor is focus!', cm)
    },
    onCmCodeChange(newCode) {
      if (this.code == '') {
        this.$socketIO.emit('write-file', {
          path: this.path,
          code: newCode,
        });

        this.code = newCode;
        return;
      }

      // console.log('this is new code', newCode);
      let diff = gitDiff(
        this.code,
        newCode
      );
      if (typeof(diff) == 'string') {
        const diffArray = diff.split('\n');
        let lineNumberAdd = 1;
        let lineNumberDel = 1;
        let lastLine = '';
        let chunk = [];
        let chunkStartNumberAdd = 0;
        let chunkStartNumberDel = 0;
        let chunks = [];
        const handleChunk = (item = '') => {
          if (chunk.length != 0) {
            if (item) {
              chunk.push(item);
            }
            const numAdd = lineNumberAdd - chunkStartNumberAdd;
            const numDel = lineNumberDel - chunkStartNumberDel;
            const header = `@@ -${chunkStartNumberDel},${numDel} +${chunkStartNumberAdd},${numAdd} @@`;
            chunks.push(header, ...chunk);
            chunk = [];
          }
        };
        diffArray.forEach((item) => {
          if (chunk.length == 0) {
            chunkStartNumberAdd = lineNumberAdd;
            chunkStartNumberDel = lineNumberDel;
          }

          const char = item.substr(0, 1);
          if (char == ' ') {
            lineNumberAdd++;
            lineNumberDel++;

            handleChunk(item);
          } else if (char) {
            if (char == '+') {
              lineNumberAdd++;
            } else if (char == '-') {
              lineNumberDel++;
            }

            chunk.push(item);
          }
        });

        handleChunk();
        const codeDiff = chunks.join('\n');

        this.$socketIO.emit('edit-file', {
          path: this.path,
          code_diff: codeDiff,
        });
        console.log(codeDiff);
      }
      this.code = newCode;
    },
    onCmBlur(newCode) {
      // console.log(newCode);
    }
  },
  computed: {
    codemirror() {
      return this.$refs.myCm.codemirror
    }
  },
  async mounted() {
    this.$socketIO.on('read-file', (data) => {
      this.code = data;
    });

    this.$socketIO.emit('read-file', {path: this.path});
    // console.log('this is current codemirror object', this.codemirror)
  }
}
</script>

<style>
.CodeMirror {
  position: absolute;
  height: 100%;
  width: 100%;
}
</style>
